RPM Support - Issue #8787

"UnboundLocalError: local variable 'result’ referenced before assignment” on attempt to sync some
repos
05/20/2021 01:32 PM - sskracic@redhat.com
Description

Today | was trying to sync some Red Hat repos with fresh pulp-rpm 3.12.0 release. Everything went well, except for couple of repos
that generated this stack trace in the logs:

May 20 11:20:17 pulp3.skracic.net rg[1495551]: pulp [612c4427c121435c9feal0b933098clcd]: pulp_rpm.a
pp.tasks.synchronizing:INFO: Synchronizing: repository=rhel-8
—for—-aarché64-appstream-beta-source-rhui-rpms remote=rhel-8-for-aarch64-appstream-beta-source-rhui-
rpms

May 20 11:20:17 pulp3.skracic.net rq[1495559]: pulp [9e8d4c3e69de43b58bb023182fe0db84]: rg.worker:
ERROR: Traceback (most recent call last):

May 20 11:20:17 pulp3.skracic.net rqg[1495559]: File "/usr/local/lib/pulp/lib64/python3.6/site-pa
ckages/rg/worker.py", line 1013, in perform_job

May 20 11:20:17 pulp3.skracic.net rg[1495559]: rv = job.perform/()

May 20 11:20:17 pulp3.skracic.net rq[1495559]: File "/usr/local/lib/pulp/lib64/python3.6/site-pa
ckages/rq/job.py", line 709, in perform

May 20 11:20:17 pulp3.skracic.net rg[l1495559]: self._result = self._execute()

May 20 11:20:17 pulp3.skracic.net rg[1495559]: File "/usr/local/lib/pulp/lib64/python3.6/site-pa
ckages/rqg/job.py", line 732, in _execute

May 20 11:20:17 pulp3.skracic.net rg[1495559]: result = self.func(*self.args, **self.kwargs)
May 20 11:20:17 pulp3.skracic.net rg[1495559]: File "/usr/local/lib/pulp/src/pulp-rpm/pulp_rpm/a
pp/tasks/synchronizing.py", line 227, in synchronize

May 20 11:20:17 pulp3.skracic.net rg[1495559]: remote_url = fetch_remote_url (remote)

May 20 11:20:17 pulp3.skracic.net rq[1495559]: File "/usr/local/lib/pulp/src/pulp-rpm/pulp_rpm/a
pp/tasks/synchronizing.py", line 141, in fetch_remote_url

May 20 11:20:17 pulp3.skracic.net rg[1495559]: if get_repomd_file (remote, remote_url):

May 20 11:20:17 pulp3.skracic.net rg[1495559]: File "/usr/local/lib/pulp/src/pulp-rpm/pulp_rpm/a
pp/tasks/synchronizing.py", line 110, in get_repomd_file

May 20 11:20:17 pulp3.skracic.net rg[1495559]: return result

May 20 11:20:17 pulp3.skracic.net rg[1495559]: UnboundLocalError: local variable 'result' referenc
ed before assignment

Upon further inspection, it looks like the repos themselves have been "turned off" following the RHEL 8.4 GA, and when tried to
download using the command line utilities, 403 Forbidden error code is retrieved.

So it looks like the exception handling should deal with 403 returned from the remote URL.

My Pulp installation is running on RHEL 8, BTW.

Related issues:

Related to Pulp - Story #8873: pulp 3 stops when encounters 403 error CLOSED - DUPLICATE
Has duplicate RPM Support - Issue #9019: A variable referenced before assignm... CLOSED - DUPLICATE
Has duplicate RPM Support - Issue #9022: errors fetching repomd.xml will fail... CLOSED - DUPLICATE
Copied to RPM Support - Backport #9027: Backport 8787 to 3.13.3 CLOSED - CURRENTRELEASE
Associated revisions

Revision 727b530b - 07/07/2021 10:32 PM - dalley

Fix unbound local error when Pulp receives a non-404 ClientResponseError
If Pulp receives a ClientResponseError when attempting to download a file, but the status code isn't 404, then we go down the wrong code path.

closes: #8787 https://pulp.plan.io/issues/8787

History

#1 - 05/20/2021 06:09 PM - ttereshc
- Triaged changed from No to Yes

- Sprint set to Sprint 97

#2 - 05/27/2021 05:19 AM - dalley
- Status changed from NEW to POST

- Assignee set to zhunting

#3 - 05/27/2021 05:52 AM - pulpbot
PR: https://github.com/pulp/pulp_rpm/pull/2008

#4 - 06/02/2021 05:49 PM - dalley

- Assignee changed from zhunting to dalley

whoops

#5 - 06/02/2021 06:03 PM - rchan
- Sprint changed from Sprint 97 to Sprint 98

#6 - 06/17/2021 05:59 PM - dalley
- Related to Story #8873: pulp 3 stops when encounters 403 error added

#7 - 06/18/2021 11:14 PM - rchan
- Sprint changed from Sprint 98 to Sprint 99

#8 - 07/02/2021 09:23 PM - rchan
- Sprint changed from Sprint 99 to Sprint 100

#9 - 07/06/2021 04:36 PM - dalley

- Related to Issue #9019: A variable referenced before assignment while reading repomd added

#10 - 07/06/2021 04:36 PM - dalley

- Related to deleted (Issue #9019: A variable referenced before assignment while reading repomd )

#11 - 07/06/2021 04:36 PM - dalley

- Has duplicate Issue #9019: A variable referenced before assignment while reading repomd added

#12 - 07/06/2021 11:14 PM - dalley

- Has duplicate Issue #9022: errors fetching repomd.xml will fail with python error 'local variable 'result’ referenced before assignment' added

#13 - 07/07/2021 10:32 PM - dalley
- Status changed from POST to MODIFIED

Applied in changeset 727b530bbd0e74041c49808b19e1a0333cff2570.

#14 - 07/07/2021 10:34 PM - dalley
- Copied to Backport #9027: Backport 8787 to 3.13.3 added
#15 - 07/07/2021 11:10 PM - dalley
- Sprint/Milestone set to 3.13.3

#16 - 07/13/2021 10:36 PM - dalley
- Status changed from MODIFIED to CLOSED - CURRENTRELEASE
